#line 1 "D:/mikroE Projects/mikroC for PIC Projects/Temperature OW_CAN Code/Temp_OW_CAN.c"
#line 10 "D:/mikroE Projects/mikroC for PIC Projects/Temperature OW_CAN Code/Temp_OW_CAN.c"
unsigned char Can_Init_Flags,Can_Send_Flags,Can_Rcv_Flags;
unsigned char Rx_Data_Len,Tx_Data_Len;
char RxTx_Data[8];
char Msg_Rcvd;
long Rx_ID,Tx_ID;







void Init(void);
unsigned int ReadTempSensor(void);
void ReadCan(void);
void WriteCan(void);



void main()
{
 Init();

 do{
 LATC.B0 ^=1;
 ReadCan();

 if(RxTx_Data[0] == 'T'){WriteCan();RxTx_Data[0] = 0;}
 Delay_ms(80);
 }while (1);
}


unsigned int ReadTempSensor()
{
 unsigned int temp = 0;

 Ow_Reset(&PORTA, 5);
 Ow_Write(&PORTA, 5,0xCC);
 Ow_Write(&PORTA, 5,0x44);
 Delay_us(120);

 Ow_Reset(&PORTA, 5);
 Ow_Write(&PORTA, 5,0xCC);
 Ow_Write(&PORTA, 5,0xBE);

 temp = Ow_Read(&PORTA,5);
 temp = (Ow_Read(&PORTA,5)<< 8) + temp;
 return temp;
}


void ReadCan(void)
{
 Msg_Rcvd = CANRead(&Rx_ID,RxTx_Data,&Rx_Data_Len,&Can_Rcv_Flags);
 if(Msg_Rcvd !=0){
 Msg_Rcvd = 0;
 switch (Rx_ID)
 {
 case 0x211:
 LATC.B1 ^=1;
 break;
 case 0x213:
 asm nop;
 break;
 }
 }
}


void WriteCan(void)
{
 unsigned int TempRaw = 0;
 TempRaw = (ReadTempSensor()/0.01);
 RxTx_Data[0] =(TempRaw &0xFF);
 RxTx_Data[1] =(TempRaw >>8);
 RxTx_Data[2]= 0;
 RxTx_Data[3]= 0;
 RxTx_Data[4]= 0;
 RxTx_Data[5]= 0;
 RxTx_Data[6]= 0;
 RxTx_Data[7]= 0;
 Tx_Data_Len = 8;
 Tx_ID = 0x210;
 CANWrite(Tx_ID,RxTx_Data,Tx_Data_Len,Can_Send_Flags);
 LATC.B2 ^=1;
}


void Init(void)
{
 ADCON1 = 0x0F;
 CMCON = 0x07;
 TRISC.B0 = 0;
 TRISC.B1 = 0;
 TRISC.B2 = 0;
 LATC = 0;



 Can_Init_Flags = 0;
 Can_Send_Flags = 0;
 Can_Rcv_Flags = 0;

 Can_Send_Flags = _CAN_TX_PRIORITY_0 &
 _CAN_TX_STD_FRAME &
 _CAN_TX_NO_RTR_FRAME;

 Can_Init_Flags = _CAN_CONFIG_SAMPLE_THRICE &
 _CAN_CONFIG_PHSEG2_PRG_ON &
 _CAN_CONFIG_STD_MSG &
 _CAN_CONFIG_DBL_BUFFER_ON &
 _CAN_CONFIG_VALID_STD_MSG &
 _CAN_CONFIG_LINE_FILTER_OFF;

 CANInitialize(1,4,5,3,1,Can_Init_Flags);
 CANSetOperationMode(_CAN_MODE_CONFIG,0xFF);
 CANSetMask(_CAN_MASK_B1,-1,_CAN_CONFIG_STD_MSG);
 CANSetMask(_CAN_MASK_B2,-1,_CAN_CONFIG_STD_MSG);
 CANSetFilter(_CAN_FILTER_B1_F1,0x211,_CAN_CONFIG_STD_MSG);
 CANSetOperationMode(_CAN_MODE_NORMAL,0xFF);
}
