#line 1 "D:/mikroE Projects/mikroC for dsPIC Projects/Temperature_OW_CAN_MasterCode/Temp_Ow_CAN_Master.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for dspic/include/built_in.h"
#line 10 "D:/mikroE Projects/mikroC for dsPIC Projects/Temperature_OW_CAN_MasterCode/Temp_Ow_CAN_Master.c"
unsigned int Can_Init_Flags,
Can_Send_Flags, Can_Rcv_Flags;
unsigned int Rx_Data_Len;
unsigned int Tx_Data_Len;
char Rx_Data[8];
char Tx_Data[8];
char Msg_Rcvd;
unsigned long RxID;
unsigned long Tx_ID;


sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB6_bit;
sbit LCD_D4 at LATD4_bit;
sbit LCD_D5 at LATD5_bit;
sbit LCD_D6 at LATD6_bit;
sbit LCD_D7 at LATD7_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB6_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;





const unsigned short TEMP_RESOLUTION = 9;
char *text = "000.0000";
unsigned char OldState,NewState ,TempAct;
unsigned temp;

struct ControlFlags
{
 unsigned getTemp :1;
 unsigned FanOn :1;
 unsigned res :14;
}Flag;
#line 66 "D:/mikroE Projects/mikroC for dsPIC Projects/Temperature_OW_CAN_MasterCode/Temp_Ow_CAN_Master.c"
void Init(void);
void LcdInit(void);
void ReadCan(void);
void WriteCan(void);
void Display_Temperature(unsigned int temp2write);



void Timer1Int() iv IVT_ADDR_T1INTERRUPT
{
 T1IF_bit = 0;
 if(Flag.FanOn){Flag.getTemp =  1 ;}
 else{Flag.getTemp =  0 ;}
}



void main()
{



 Init();



 LcdInit();



 Flag.getTemp =  0 ;
 Flag.FanOn =  0 ;
 OldState = NewState = 0;
 temp = 0;



 do
 {

 if (Button(&PORTB,0,300,0))
 {
 NewState = OldState ^=1;
 if(NewState== 1 ){Flag.FanOn =  1 ;LATC.B1 =  1 ;}
 else{Flag.FanOn =  0 ;LATC.B1 =  0 ;}
 OldState = NewState;
 }

 WriteCan();

 ReadCan();

 if(Flag.FanOn){Display_Temperature(temp);}
 else {Display_Temperature(temp = 0);}
 }while(1);
}


void Display_Temperature(unsigned int temp2write)
{
 const unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
 char temp_whole;
 unsigned int temp_fraction;


 if (temp2write & 0x8000) {
 text[0] = '-';
 temp2write = ~temp2write + 1;
 }


 temp_whole = temp2write >> RES_SHIFT ;
 TempAct = temp_whole;

 if (temp_whole/100)
 text[0] = temp_whole/100 + 48;
 else
 text[0] = '0';

 text[1] = (temp_whole/10)%10 + 48;
 text[2] = temp_whole%10 + 48;


 temp_fraction = temp2write << (4-RES_SHIFT);
 temp_fraction &= 0x000F;
 temp_fraction *= 625;


 text[4] = temp_fraction/1000 + 48;
 text[5] = (temp_fraction/100)%10 + 48;
 text[6] = (temp_fraction/10)%10 + 48;
 text[7] = temp_fraction%10 + 48;


 Lcd_Out(2, 5, text);
}


void ReadCan(void)
{

 Msg_Rcvd = CAN2Read(&RxID , Rx_Data , &Rx_Data_Len, &Can_Rcv_Flags);
 if (Msg_Rcvd )
 {
 switch (RxID)
 {
 case 0x210 :
 temp = ((Rx_Data[1]*256) + Rx_Data[0]) * 0.01;
 break;
 case 0x200 :
 asm nop ;
 break;
 }
 }
}

void WriteCan(void)
{
 if(Flag.getTemp)
 {
 Tx_Data[0] = 'T';
 Tx_Data[1] = TempAct;
 Tx_Data[2] = 0;
 Tx_Data[3] = 0;
 Tx_Data[4] = 0;
 Tx_Data[5] = 0;
 Tx_Data[6] = 0;
 Tx_Data[7] = 0;
 Tx_Data_Len = 8;
 Tx_ID = 0x211;
 CAN2Write(Tx_ID,Tx_Data, Tx_Data_Len,Can_Send_Flags);
 }
 Flag.getTemp =  0 ;
}

void LcdInit(void)
{
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1, 1, " Temperature:   ");

 Lcd_Chr(2,13,223);


 Lcd_Chr(2,14,'C');
}

void Init(void)
{
 ADPCFG = 0xFFFF;
 TRISBbits.TRISB0 = 1;
 TRISCbits.TRISC1 = 0;

 IPC0 = IPC0 | 0x1000;
 T1IF_bit = 0;
 T1IE_bit =1;
 T1CON = 0x8030;

 Can_Init_Flags = 0;
 Can_Send_Flags = 0;
 Can_Rcv_Flags = 0;

 Can_Send_Flags = _CAN_TX_PRIORITY_0 &
 _CAN_TX_STD_FRAME &
 _CAN_TX_NO_RTR_FRAME;

 Can_Init_Flags = _CAN_CONFIG_SAMPLE_THRICE &
 _CAN_CONFIG_PHSEG2_PRG_ON &
 _CAN_CONFIG_STD_MSG &
 _CAN_CONFIG_DBL_BUFFER_ON &
 _CAN_CONFIG_MATCH_MSG_TYPE &
 _CAN_CONFIG_LINE_FILTER_OFF;

 CAN2Initialize(1,2,5,3,1,Can_Init_Flags) ;



 C2CTRL.CANCKS = 1;
 CAN2SetOperationMode(_CAN_MODE_CONFIG,0xFF);
 CAN2SetMask(_CAN_MASK_B1,-1,_CAN_CONFIG_MATCH_MSG_TYPE & _CAN_CONFIG_STD_MSG);
 CAN2SetMask(_CAN_MASK_B2,-1,_CAN_CONFIG_MATCH_MSG_TYPE & _CAN_CONFIG_STD_MSG);
 CAN2SetFilter(_CAN_FILTER_B1_F1, 0x100 ,_CAN_CONFIG_STD_MSG);
 CAN2SetFilter(_CAN_FILTER_B1_F2, 0x101 ,_CAN_CONFIG_STD_MSG);
 CAN2SetFilter(_CAN_FILTER_B2_F1, 0x200 ,_CAN_CONFIG_STD_MSG);
 CAN2SetFilter(_CAN_FILTER_B2_F2, 0x210 ,_CAN_CONFIG_STD_MSG);
 CAN2SetFilter(_CAN_FILTER_B2_F3, 0x300 ,_CAN_CONFIG_STD_MSG);
 CAN2SetFilter(_CAN_FILTER_B2_F4, 0x310 ,_CAN_CONFIG_STD_MSG);
 CAN2SetOperationMode(_CAN_MODE_NORMAL,0xFF);
 Msg_Rcvd = 0;

}
